/*!
 * Lightbox v2.11.4
 * by Lokesh Dhakar
 *
 * More info:
 * http://lokeshdhakar.com/projects/lightbox2/
 *
 * Copyright Lokesh Dhakar
 * Released under the MIT license
 * https://github.com/lokesh/lightbox2/blob/master/LICENSE
 *
 * @preserve
 */

// Uses Node, AMD or browser globals to create a module.
(function (root, factory) {
    if (typeof define === 'function' && define.amd) {
        // AMD. Register as an anonymous module.
        define(['jquery'], factory);
    } else if (typeof exports === 'object') {
        // Node. Does not work with strict CommonJS, but
        // only CommonJS-like environments that support module.exports,
        // like Node.
        module.exports = factory(require('jquery'));
    } else {
        // Browser globals (root is window)
        root.lightbox = factory(root.jQuery);
    }
}(this, function ($) {

  function Lightbox(options) {
    this.album = [];
    this.currentImageIndex = void 0;
    this.init();

    // options
    this.options = $.extend({}, this.constructor.defaults);
    this.option(options);
  }

  // Descriptions of all options available on the demo site:
  // http://lokeshdhakar.com/projects/lightbox2/index.html#options
  Lightbox.defaults = {
    albumLabel: 'Image %1 of %2',
    alwaysShowNavOnTouchDevices: false,
    fadeDuration: 600,
    fitImagesInViewport: true,
    imageFadeDuration: 600,
    positionFromTop: 50,
    resizeDuration: 700,
    showImageNumberLabel: true,
    wrapAround: false,
    disableScrolling: false,
    /*
    Sanitize Title
    If the caption data is trusted, for example you are hardcoding it in, then leave this to false.
    This will free you to add html tags, such as links, in the caption.

    If the caption data is user submitted or from some other untrusted source, then set this to true
    to prevent xss and other injection attacks.
     */
    sanitizeTitle: false
	, hasVideo: true
	, onMediaChange: (oMedia) => {}
	, onClosing: () => {}
  };

  Lightbox.prototype.option = function(options) {
    $.extend(this.options, options);
  };

  Lightbox.prototype.imageCountLabel = function(currentImageNum, totalImages) {
    return this.options.albumLabel.replace(/%1/g, currentImageNum).replace(/%2/g, totalImages);
  };

  Lightbox.prototype.init = function() {
    var self = this;
    // Both enable and build methods require the body tag to be in the DOM.
    $(document).ready(function() {
      self.enable();
      self.build();
    });
  };

  // Loop through anchors and areamaps looking for either data-lightbox attributes or rel attributes
  // that contain 'lightbox'. When these are clicked, start lightbox.
  Lightbox.prototype.enable = function() {
    var self = this;
    $('body').on('click', 'a[rel^=lightbox], area[rel^=lightbox], a[data-lightbox], area[data-lightbox]', function(event) {
      self.start($(event.currentTarget));
      return false;
    });
  };

  // Build html for the lightbox and the overlay.
  // Attach event handlers to the new DOM elements. click click click
  Lightbox.prototype.build = function() {
    if ($('#lightbox').length > 0) {
        return;
    }

    var self = this;

    // The two root notes generated, #lightboxOverlay and #lightbox are given
    // tabindex attrs so they are focusable. We attach our keyboard event
    // listeners to these two elements, and not the document. Clicking anywhere
    // while Lightbox is opened will keep the focus on or inside one of these
    // two elements.
    //
    // We do this so we can prevent propogation of the Esc keypress when
    // Lightbox is open. This prevents it from intefering with other components
    // on the page below.
    //
    // Github issue: https://github.com/lokesh/lightbox2/issues/663
    $('\
		<div id="lightboxOverlay" tabindex="-1" class="lightboxOverlay"></div>\
		<div id="lightbox" tabindex="-1" class="lightbox">\
			<div class="lb-outerContainer">\
				<div class="lb-container">\
					<img class="lb-image" src="data:image/gif;base64,R0lGODlhAQABAIAAAP///wAAACH5BAEAAAAALAAAAAABAAEAAAICRAEAOw==" alt="" />\
					<div class="lb-nav">\
						<div class="lb-prev-area">\
							<a class="lb-prev" aria-label="Previous image" href="" role="button"></a>\
						</div>\
						<div class="lb-next-area">\
							<a class="lb-next" aria-label="Next image" href="" role="button"></a>\
						</div>\
					</div>\
				<div class="lb-loader">\
					<a class="lb-cancel" href="#"></a>\
				</div>\
			</div>\
		</div>\
		<div class="lb-dataContainer desktop">\
			<div class="lb-data">\
				<div class="lb-details">\
					<span class="lb-caption"></span>\
					<span class="lb-number"></span>\
				</div>\
				<div class="lb-closeContainer">\
					<a class="lb-close" role="button"></a>\
				</div>\
			</div>\
		</div>\
	').appendTo($('body'));

    // Cache jQuery objects
    this.$lightbox       = $('#lightbox');
    this.$overlay        = $('#lightboxOverlay');
    this.$outerContainer = this.$lightbox.find('.lb-outerContainer');
    this.$container      = this.$lightbox.find('.lb-container');
    this.$image          = this.$lightbox.find('.lb-image');
    this.$nav            = this.$lightbox.find('.lb-nav');
	
	if(self.options.hasVideo) {
		this.$video = $('<video class="lb-video" controls autoplay></video>');
		this.$image.after(this.$video);
		this.videoBorderWidth = {
			top: parseInt(this.$video.css('border-top-width'), 10),
			right: parseInt(this.$video.css('border-right-width'), 10),
			bottom: parseInt(this.$video.css('border-bottom-width'), 10),
			left: parseInt(this.$video.css('border-left-width'), 10)
		};
	}

    // Store css values for future lookup
    this.containerPadding = {
      top: parseInt(this.$container.css('padding-top'), 10),
      right: parseInt(this.$container.css('padding-right'), 10),
      bottom: parseInt(this.$container.css('padding-bottom'), 10),
      left: parseInt(this.$container.css('padding-left'), 10)
    };

    this.imageBorderWidth = {
      top: parseInt(this.$image.css('border-top-width'), 10),
      right: parseInt(this.$image.css('border-right-width'), 10),
      bottom: parseInt(this.$image.css('border-bottom-width'), 10),
      left: parseInt(this.$image.css('border-left-width'), 10)
    };

    // Attach event handlers to the newly minted DOM elements
	this.$overlay.hide().add(this.$lightbox.find('.lb-dataContainer')).on('click', function() {
	  self.end();
      return false;
    });

    this.$lightbox.hide().on('click', function(event) {
      if ($(event.target).attr('id') === 'lightbox') {
        self.end();
      }
    });

    this.$outerContainer.on('click', function(event) {
      if ($(event.target).attr('id') === 'lightbox') {
        self.end();
      }
      return false;
    });

    this.$lightbox.find('.lb-prev').on('click', function() {
      if (self.currentImageIndex === 0) {
        self.changeImage(self.album.length - 1);
      } else {
        self.changeImage(self.currentImageIndex - 1);
      }
      return false;
    });

    this.$lightbox.find('.lb-next').on('click', function() {
      if (self.currentImageIndex === self.album.length - 1) {
        self.changeImage(0);
      } else {
        self.changeImage(self.currentImageIndex + 1);
      }
      return false;
    });

    /*
      Show context menu for image on right-click

      There is a div containing the navigation that spans the entire image and lives above of it. If
      you right-click, you are right clicking this div and not the image. This prevents users from
      saving the image or using other context menu actions with the image.

      To fix this, when we detect the right mouse button is pressed down, but not yet clicked, we
      set pointer-events to none on the nav div. This is so that the upcoming right-click event on
      the next mouseup will bubble down to the image. Once the right-click/contextmenu event occurs
      we set the pointer events back to auto for the nav div so it can capture hover and left-click
      events as usual.
     */
    this.$nav.on('mousedown', function(event) {
      if (event.which === 3) {
        self.$nav.css('pointer-events', 'none');

        self.$lightbox.one('contextmenu', function() {
          setTimeout(function() {
              this.$nav.css('pointer-events', 'auto');
          }.bind(self), 0);
        });
      }
    });


    this.$lightbox.find('.lb-loader, .lb-close').on('click keyup', function(e) {
      // If mouse click OR 'enter' or 'space' keypress, close LB
      if (
        e.type === 'click' || (e.type === 'keyup' && (e.which === 13 || e.which === 32))) {
        self.end();
        return false;
      }
    });
  };

  // Show overlay and lightbox. If the image is part of a set, add siblings to album array.
  Lightbox.prototype.start = function($link) {
    var self    = this;
    var $window = $(window);

    $window.on('resize', $.proxy(this.sizeOverlay, this));

    this.sizeOverlay();

	//Manage Zoom Event
    this.$nav.mousewheel((e) => {
    	var asImg = self.album[this.currentImageIndex];
    	if(!asImg.type != 'video') {
    		let asTransform = this.$image.css('transform').replace(/[^0-9\-.,]/g, '').split(',');
	    	let fOldZoom = parseFloat(asTransform[0] || 1);
	    	let fOldTranslateX = parseFloat(asTransform[4] || 0);
	    	let fOldTranslateY = parseFloat(asTransform[5] || 0);
	    	let fNewZoom = Math.min(Math.max(fOldZoom + e.deltaY / 10, 1), Math.max(asImg.width/this.$image.width(), asImg.height/this.$image.height()));

	    	let fTransX = fOldTranslateX + (fNewZoom - fOldZoom) * (this.$image.width()/2 - e.offsetX);
	    	let fTransY = fOldTranslateY + (fNewZoom - fOldZoom) * (this.$image.height()/2 - e.offsetY);
	    	let fTransMaxX = (fNewZoom - 1) * this.$image.width() / 2;
	    	let fTransMaxY = (fNewZoom - 1) * this.$image.height() / 2;

	    	fTransX = Math.max(Math.min(fTransX, fTransMaxX), fTransMaxX * -1);
	    	fTransY = Math.max(Math.min(fTransY, fTransMaxY), fTransMaxY * -1);

	    	this.$image.css('--scale', fNewZoom);
			this.$container.toggleClass('moveable', (fNewZoom > 1));
	    	this.$image.css('--translate-x', fTransX+'px');
            this.$image.css('--translate-y', fTransY+'px');
    	}
    });

	//Manage Repositioning Event	
	this.$nav.on('mousedown', (e) => {
		if(this.$image.css('--scale') > 1) {
			//The following block gets the X/Y offset (the difference between where it starts and where it was clicked)
			this.gMouseDownOffsetX = e.clientX - parseFloat(this.$image.css('--translate-x') || 0);
			this.gMouseDownOffsetY = e.clientY - parseFloat(this.$image.css('--translate-y') || 0);

			//Change cursor
			this.$container.addClass('moving');

			$window.on('mousemove', divMove);
		}
	});

	$window.on('mouseup', () => {
		$window.off('mousemove', divMove);
		this.$container.removeClass('moving');
	});

	function divMove(e){
		let iZoom = self.$image.css('--scale');
		let fTransX = e.clientX - self.gMouseDownOffsetX;
		let fTransY = e.clientY - self.gMouseDownOffsetY;
		let fTransMaxX = (iZoom - 1) * self.$image.width() / 2;
		let fTransMaxY = (iZoom - 1) * self.$image.height() / 2;

		fTransX = Math.max(Math.min(fTransX, fTransMaxX), fTransMaxX * -1);
		fTransY = Math.max(Math.min(fTransY, fTransMaxY), fTransMaxY * -1);

		self.$image.css('--translate-x', fTransX + 'px');
		self.$image.css('--translate-y', fTransY + 'px');
	}

    this.album = [];
    var imageNumber = 0;

    // Support both data-lightbox attribute and rel attribute implementations
    var dataLightboxValue = $link.attr('data-lightbox');
    var $links;

    if (dataLightboxValue) {
      $links = $($link.prop('tagName') + '[data-lightbox="' + dataLightboxValue + '"]');
      for (var i = 0; i < $links.length; i = ++i) {
        this.addToAlbum($($links[i]));
        if ($links[i] === $link[0]) {
          imageNumber = i;
        }
      }
    } else {
      if ($link.attr('rel') === 'lightbox') {
        // If image is not part of a set
        this.addToAlbum($link);
      } else {
        // If image is part of a set
        $links = $($link.prop('tagName') + '[rel="' + $link.attr('rel') + '"]');
        for (var j = 0; j < $links.length; j = ++j) {
			this.addToAlbum($($links[j]));
          if ($links[j] === $link[0]) {
            imageNumber = j;
          }
        }
      }
    }

    // Position Lightbox
    this.$lightbox.fadeIn(this.options.fadeDuration);

    // Disable scrolling of the page while open
    if (this.options.disableScrolling) {
      $('body').addClass('lb-disable-scrolling');
    }

    this.changeImage(imageNumber);
  };

  Lightbox.prototype.addToAlbum = function($link) {
	this.album.push({
	  alt: $link.attr('data-alt'),
	  link: $link.attr('href'),
	  title: $link.attr('data-title') || $link.attr('title'),

	  orientation: $link.attr('data-orientation'),
	  type: $link.attr('data-type'),
	  id: $link.attr('data-id'),
	  $Media: $link.attr('data-type')=='video'?this.$video:this.$image,
	  width: $link.find('img').attr('width'),
	  height: $link.find('img').attr('height'),
	  set: $link.attr('data-lightbox') || $link.attr('rel')
	});
  }
  
  Lightbox.prototype.getMaxSizes = function(iMediaWidth, iMediaHeight, sMediaType) {
	var iWindowWidth = $(window).width();
	var iWindowHeight = $(window).height();
	var oBorder = (sMediaType=='image')?this.imageBorderWidth:this.videoBorderWidth;
	var iMaxMediaWidth  = iWindowWidth - this.containerPadding.left - this.containerPadding.right - oBorder.left - oBorder.right;
	var iMaxMediaHeight = iWindowHeight - this.containerPadding.top - this.containerPadding.bottom - oBorder.top - oBorder.bottom - this.options.positionFromTop;

	var iDataMaxWidth = this.$lightbox.find('.lb-dataContainer').width(), iDataMaxHeight = this.$lightbox.find('.lb-dataContainer').height();
	var iImageRatio = iMediaWidth / iMediaHeight;

	//Case horizontal
	var iHeightH = Math.min(iMaxMediaHeight, iMediaHeight);
	var iWidthH = Math.min(iHeightH * iImageRatio, iMaxMediaWidth - iDataMaxWidth);
	var iSurfaceH = Math.min(iHeightH, iWidthH / iImageRatio) * iWidthH;

	//Case vertical
	var iWidthV = Math.min(iMaxMediaWidth, iMediaWidth);
	var iHeightV = Math.min(iWidthV / iImageRatio, iMaxMediaHeight - iDataMaxHeight);
	var iSurfaceV = Math.min(iWidthV, iHeightV * iImageRatio) * iHeightV;

	var sDirection = (iSurfaceV > iSurfaceH)?'vertical':'horizontal';

	if(sDirection == 'vertical') iMaxMediaHeight -= iDataMaxHeight;
	else iMaxMediaWidth -= iDataMaxWidth;

	return {maxWidth: iMaxMediaWidth, maxHeight: iMaxMediaHeight, direction: sDirection};
  };

  Lightbox.prototype.updateSize = function(iMediaNumber) {
	var oMedia = this.album[iMediaNumber];
	var sFileType = oMedia.link.split('.').slice(-1)[0];
	var oMaxSizes = this.getMaxSizes(oMedia.width, oMedia.height, oMedia.type);
	var iMaxMediaWidth = oMaxSizes.maxWidth;
	var iMaxMediaHeight = oMaxSizes.maxHeight;
	this.$lightbox.removeClass('vertical horizontal').addClass(oMaxSizes.direction);

	/*
	Since many SVGs have small intrinsic dimensions, but they support scaling
	up without quality loss because of their vector format, max out their
	size.
	*/
	if(sFileType === 'svg') {
		oMedia.$Media.width(iMaxMediaWidth);
		oMedia.$Media.height(iMaxMediaHeight);
	}

	if(this.options.fitImagesInViewport) {
		//Check if image size is larger than maxWidth|maxHeight in settings
		if(this.options.maxWidth && this.options.maxWidth < iMaxMediaWidth) iMaxMediaWidth = this.options.maxWidth;
		if(this.options.maxHeight && this.options.maxHeight < iMaxMediaHeight) iMaxMediaHeight = this.options.maxHeight;
	}
	else {
		iMaxMediaWidth = this.options.maxWidth || oMedia.width || iMaxMediaWidth;
		iMaxMediaHeight = this.options.maxHeight || oMedia.height || iMaxMediaHeight;
	}

	//Is the current image's width or height is greater than the maxImageWidth or maxImageHeight
	//option than we need to size down while maintaining the aspect ratio.
	var iMediaFinalWidth, iMediaFinalHeight;
	if((oMedia.width > iMaxMediaWidth) || (oMedia.height > iMaxMediaHeight)) {
		if ((oMedia.width / iMaxMediaWidth) > (oMedia.height / iMaxMediaHeight)) {
			iMediaFinalWidth = iMaxMediaWidth;
			iMediaFinalHeight = Math.round(oMedia.height / (oMedia.width / iMaxMediaWidth));
		} else {
			iMediaFinalWidth = Math.round(oMedia.width / (oMedia.height / iMaxMediaHeight));
			iMediaFinalHeight = iMaxMediaHeight;
		}
	}
	else {
		iMediaFinalWidth = oMedia.width;
		iMediaFinalHeight = oMedia.height;
	}

	oMedia.$Media.width(iMediaFinalWidth);
	oMedia.$Media.height(iMediaFinalHeight);
	this.sizeContainer(iMediaFinalWidth, iMediaFinalHeight, oMedia.type);
  };

  // Hide most UI elements in preparation for the animated resizing of the lightbox.
  Lightbox.prototype.changeImage = function(imageNumber) {
    var self = this;
    var filename = this.album[imageNumber].link;

    // Disable keyboard nav during transitions
    this.disableKeyboardNav();

    // Show loading state
    this.$overlay.fadeIn(this.options.fadeDuration);
    $('.lb-loader').fadeIn('slow');

    this.$lightbox.find('.lb-image, .lb-video, .lb-nav, .lb-prev, .lb-next, .lb-number, .lb-caption, .lb-close').hide();
	this.$image.css({'--scale': '1', '--translate-x': '0', '--translate-y': '0'});
	self.$lightbox.find('.lb-dataContainer').css({width:'200px', height:'30px'});
    this.$outerContainer.addClass('animating');
	this.$container.removeClass('moveable moving');

	this.options.onMediaChange(self.album[imageNumber]);

	var $hasVideoNav = this.$container.hasClass('lb-video-nav');
	switch(self.album[imageNumber].type) {
		case 'video':
			self.$image.removeAttr('src');
			this.$video.on('loadedmetadata', function(){
				self.album[imageNumber].width = this.videoWidth;
				self.album[imageNumber].height = this.videoHeight;
				self.updateSize(imageNumber);
				$(this).off('loadedmetadata');
			});
	
			this.$video.attr('src', filename);
	
			if(!$hasVideoNav) this.$container.addClass('lb-video-nav');
			break;
		case 'image':
			this.$video.trigger('pause').removeAttr('src');
			if($hasVideoNav) this.$container.removeClass('lb-video-nav');

			// When image to show is preloaded, we send the width and height to sizeContainer()
			var preloader = new Image();
			preloader.onload = function(){
				self.$image.attr({
					'alt': self.album[imageNumber].alt,
					'src': filename
				});

				//Orientation management
				if(Math.abs(self.album[imageNumber].orientation) == 90 && preloader.width > preloader.height) {
					var sWidth = preloader.width;
					preloader.width = preloader.height;
					preloader.height = sWidth;
				}
				self.album[imageNumber].width = preloader.width;
				self.album[imageNumber].height = preloader.height;

				self.updateSize(imageNumber);
			};

			// Preload image before showing
			preloader.src = this.album[imageNumber].link;
			break;
	}

    this.currentImageIndex = imageNumber;
  };

  // Stretch overlay to fit the viewport
  Lightbox.prototype.sizeOverlay = function(e) {
    /*
    We use a setTimeout 0 to pause JS execution and let the rendering catch-up.
    Why do this? If the `disableScrolling` option is set to true, a class is added to the body
    tag that disables scrolling and hides the scrollbar. We want to make sure the scrollbar is
    hidden before we measure the document width, as the presence of the scrollbar will affect the
    number.
    */
	if(e) {
		if(typeof oResizeTimer != 'undefined') clearTimeout(oResizeTimer);
		oResizeTimer = setTimeout(
			() => {
				switch(this.album[this.currentImageIndex].type) {
					case 'image':
						this.changeImage(this.currentImageIndex);
						break;
					case 'video':
						this.updateSize(this.currentImageIndex);
						break;
				}
			},
			200
		);
	}
  };

  // Animate the size of the lightbox to fit the image we are showing
  // This method also shows the the image.
  //Lightbox.prototype.sizeContainer = function(imageWidth, imageHeight) {
	Lightbox.prototype.sizeContainer = function(imageWidth, imageHeight, media) {
		media = media || 'image';
    var self = this;

    var oldWidth  = this.$outerContainer.outerWidth();
    var oldHeight = this.$outerContainer.outerHeight();
    //var newWidth  = imageWidth + this.containerPadding.left + this.containerPadding.right + this.imageBorderWidth.left + this.imageBorderWidth.right;
    //var newHeight = imageHeight + this.containerPadding.top + this.containerPadding.bottom + this.imageBorderWidth.top + this.imageBorderWidth.bottom;
    var mediaBorderWidth = (media=='image')?this.imageBorderWidth:this.videoBorderWidth;
    var newWidth  = imageWidth + this.containerPadding.left + this.containerPadding.right + mediaBorderWidth.left + mediaBorderWidth.right;
    var newHeight = imageHeight + this.containerPadding.top + this.containerPadding.bottom + mediaBorderWidth.top + mediaBorderWidth.bottom;

    function postResize() {
      if(self.$lightbox.hasClass('vertical')) self.$lightbox.find('.lb-dataContainer').width(newWidth);
      else self.$lightbox.find('.lb-dataContainer').height(newHeight);
      self.$lightbox.find('.lb-prevLink').height(newHeight);
      self.$lightbox.find('.lb-nextLink').height(newHeight);

      // Set focus on one of the two root nodes so keyboard events are captured.
      self.$overlay.trigger('focus');

      self.showImage();
    }

    if (oldWidth !== newWidth || oldHeight !== newHeight) {
      this.$outerContainer.animate({
        width: newWidth,
        height: newHeight
      }, this.options.resizeDuration, 'swing', function() {
        postResize();
      });
    } else {
      postResize();
    }
  };

  // Display the image and its details and begin preload neighboring images.
  Lightbox.prototype.showImage = function() {
    this.$lightbox.find('.lb-loader').stop(true).hide();

    if(this.options.hasVideo && this.album[this.currentImageIndex].type == 'video') this.$lightbox.find('.lb-video').fadeIn(this.options.imageFadeDuration);
    else this.$lightbox.find('.lb-image').fadeIn(this.options.imageFadeDuration);

    this.updateNav();
    this.updateDetails();
    this.preloadNeighboringImages();
    this.enableKeyboardNav();
  };

  // Display previous and next navigation if appropriate.
  Lightbox.prototype.updateNav = function() {
    // Check to see if the browser supports touch events. If so, we take the conservative approach
    // and assume that mouse hover events are not supported and always show prev/next navigation
    // arrows in image sets.
    var alwaysShowNav = false;
    try {
      document.createEvent('TouchEvent');
      alwaysShowNav = (this.options.alwaysShowNavOnTouchDevices) ? true : false;
    } catch (e) {}

    this.$lightbox.find('.lb-nav').show();

    if (this.album.length > 1) {
      if (this.options.wrapAround) {
        if (alwaysShowNav) {
          this.$lightbox.find('.lb-prev, .lb-next').css('opacity', '1');
        }
        this.$lightbox.find('.lb-prev, .lb-next').show();
      } else {
        if (this.currentImageIndex > 0) {
          this.$lightbox.find('.lb-prev').show();
          if (alwaysShowNav) {
            this.$lightbox.find('.lb-prev').css('opacity', '1');
          }
        }
        if (this.currentImageIndex < this.album.length - 1) {
          this.$lightbox.find('.lb-next').show();
          if (alwaysShowNav) {
            this.$lightbox.find('.lb-next').css('opacity', '1');
          }
        }
      }
    }
  };

  // Display caption, image number, and closing button.
  Lightbox.prototype.updateDetails = function() {
    var self = this;

    // Enable anchor clicks in the injected caption html.
    // Thanks Nate Wright for the fix. @https://github.com/NateWr
    if (typeof this.album[this.currentImageIndex].title !== 'undefined' &&
      this.album[this.currentImageIndex].title !== '') {
      var $caption = this.$lightbox.find('.lb-caption');
      if (this.options.sanitizeTitle) {
        $caption.text(this.album[this.currentImageIndex].title);
      } else {
        $caption.html(this.album[this.currentImageIndex].title);
	  }
      $caption.add(this.$lightbox.find('.lb-close')).fadeIn('fast');
    }

    this.$outerContainer.removeClass('animating');

    this.$lightbox.find('.lb-dataContainer').fadeIn(this.options.resizeDuration, function() {
      return self.sizeOverlay();
    });
  };

  // Preload previous and next images in set.
  Lightbox.prototype.preloadNeighboringImages = function() {
    if (this.album.length > this.currentImageIndex + 1 && this.album[this.currentImageIndex + 1].type == 'image') {
      var preloadNext = new Image();
      preloadNext.src = this.album[this.currentImageIndex + 1].link;
    }
    if (this.currentImageIndex > 0 && this.album[this.currentImageIndex - 1].type == 'image') {
      var preloadPrev = new Image();
      preloadPrev.src = this.album[this.currentImageIndex - 1].link;
    }
  };

  Lightbox.prototype.enableKeyboardNav = function() {
	this.disableKeyboardNav();
    this.$lightbox.on('keyup.keyboard', $.proxy(this.keyboardAction, this));
    this.$overlay.on('keyup.keyboard', $.proxy(this.keyboardAction, this));
  };

  Lightbox.prototype.disableKeyboardNav = function() {
    this.$lightbox.off('.keyboard');
    this.$overlay.off('.keyboard');
  };

  Lightbox.prototype.keyboardAction = function(event) {
    var KEYCODE_ESC        = 27;
    var KEYCODE_LEFTARROW  = 37;
    var KEYCODE_RIGHTARROW = 39;

    var keycode = event.keyCode;
    if (keycode === KEYCODE_ESC) {
      // Prevent bubbling so as to not affect other components on the page.
      event.stopPropagation();
      this.end();
    } else if (keycode === KEYCODE_LEFTARROW) {
      if (this.currentImageIndex !== 0) {
        this.changeImage(this.currentImageIndex - 1);
      } else if (this.options.wrapAround && this.album.length > 1) {
        this.changeImage(this.album.length - 1);
      }
    } else if (keycode === KEYCODE_RIGHTARROW) {
      if (this.currentImageIndex !== this.album.length - 1) {
        this.changeImage(this.currentImageIndex + 1);
      } else if (this.options.wrapAround && this.album.length > 1) {
        this.changeImage(0);
      }
    }
  };

  // Closing time. :-(
  Lightbox.prototype.end = function() {
    this.disableKeyboardNav();

	if(this.options.hasVideo) {
		var $lbContainer = this.$lightbox.find('.lb-container');
		var $hasVideoNav = $lbContainer.hasClass('lb-video-nav');
		this.$video.trigger('pause').removeAttr('src');

		if($hasVideoNav) $lbContainer.removeClass('lb-video-nav');
	}

    $(window).off('resize', this.sizeOverlay);
	this.$nav.off('mousewheel');
    this.$lightbox.fadeOut(this.options.fadeDuration);
    this.$overlay.fadeOut(this.options.fadeDuration);

    if (this.options.disableScrolling) {
      $('body').removeClass('lb-disable-scrolling');
    }
	
	this.options.onClosing();
  };

  return new Lightbox();
}));
